"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resolvableExtensions = resolvableExtensions;
exports.modifyWebpackConfig = modifyWebpackConfig;
exports.preprocessSource = preprocessSource;

var _coffeeReactTransform = require("coffee-react-transform");

var _coffeeReactTransform2 = _interopRequireDefault(_coffeeReactTransform);

var _coffeescript = require("coffeescript");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var COFFEE = /\.coffee$/;
var CJSX = /\.cjsx$/;

function resolvableExtensions() {
  return [`.coffee`, `.cjsx`];
}

function modifyWebpackConfig(ctx) {
  // we need to use Babel to get around the ES6 export issue
  var config = ctx.args.config;

  config.loader("coffee", {
    test: COFFEE,
    loaders: ["babel", "coffee"]
  });
  config.loader("cjsx", {
    test: CJSX,
    loaders: ["babel", "coffee", "cjsx"]
  });
}

function preprocessSource(ctx) {
  var _ctx$args = ctx.args,
      filename = _ctx$args.filename,
      contents = _ctx$args.contents,
      pluginOptions = ctx.pluginOptions;
  // don't need to account for ES6, Babylon can parse it

  if (CJSX.test(filename)) {
    return (0, _coffeescript.compile)((0, _coffeeReactTransform2.default)(contents), pluginOptions);
  } else if (COFFEE.test(filename)) {
    return (0, _coffeescript.compile)(contents, pluginOptions);
  } else return null;
}